import 'package:flutter/material.dart';

import 'chip_list_item.dart';

class ChipListController extends ChangeNotifier {
  ChipListController({
    List<ChipListItem>? items,
  }) {
    if (items != null) {
      _items.addAll(items);
    }
  }

  final List<ChipListItem> _items = [];

  List<ChipListItem> get items => _items;

  void add(ChipListItem item) {
    _clearRemoveFlags();
    _items.add(item);
    notifyListeners();
  }

  void remove(ChipListItem item) {
    _items.remove(item);
    _clearRemoveFlags();
    notifyListeners();
  }

  void clear() {
    _items.clear();
    notifyListeners();
  }

  void clearRemoveFlags() {
    _clearRemoveFlags();
    notifyListeners();
  }

  void _clearRemoveFlags() {
    for (var item in _items) {
      item.removeFlag = false;
    }
  }

  void shoudRemove(ChipListItem e) {
    if (e.canDelete && e.removeFlag) {
      _items.remove(e);
      notifyListeners();
    } else if (e.canDelete) {
      _clearRemoveFlags();
      e.removeFlag = true;
      notifyListeners();
    }
  }
}
