// // ignore_for_file: prefer_const_constructors

// import 'package:flutter/material.dart';

// main() {
//   runApp(ChipApp());
// }

// class ChipApp extends StatelessWidget {
//   const ChipApp({Key? key}) : super(key: key);

//   @override
//   Widget build(BuildContext context) {
//     return MaterialApp(
//       home: Scaffold(
//         body: ChipDemo(),
//       ),
//     );
//   }
// }

// class ChipDemo extends StatefulWidget {
//   const ChipDemo({Key? key}) : super(key: key);

//   @override
//   State<StatefulWidget> createState() => _ChipDemoState();
// }

// class _ChipDemoState extends State<ChipDemo> {
//   late final ChipListController controller;

//   @override
//   void initState() {
//     super.initState();

//     controller = ChipListController(
//       items: List.generate(
//         10,
//         (index) => ChipListItem(
//           text: index.toString(),
//           icon: index < 3
//               ? Icon(
//                   Icons.settings,
//                   size: 20,
//                 )
//               : null,
//           isSelected: index % 2 == 0,
//           canDelete: index % 3 == 0,
//         ),
//       ),
//     );
//   }

//   @override
//   Widget build(BuildContext context) {
//     return Scaffold(
//       appBar: AppBar(
//         title: Text("ChipList"),
//         centerTitle: true,
//         automaticallyImplyLeading: false,
//       ),
//       body: Padding(
//         padding: EdgeInsets.all(16),
//         child: Column(
//           crossAxisAlignment: CrossAxisAlignment.center,
//           mainAxisAlignment: MainAxisAlignment.start,
//           children: <Widget>[
//             ChipList(
//               controller: controller,
//               onAddPressed: () async {
//                 final result = await showDialog<String>(
//                   context: context,
//                   builder: (context) {
//                     TextEditingController _textFieldController = TextEditingController();
//                     return AlertDialog(
//                       title: Text('Neues Label'),
//                       content: TextField(
//                         maxLength: 30,
//                         autofocus: true,
//                         controller: _textFieldController,
//                         decoration: InputDecoration(hintText: "Name..."),
//                         onSubmitted: (value) {
//                           if (value.isNotEmpty) {
//                             Navigator.pop(context, value);
//                           }
//                         },
//                       ),
//                       actions: <Widget>[
//                         TextButton(
//                           child: Text('Abbrechen'),
//                           onPressed: () => Navigator.pop(context),
//                         ),
//                         TextButton(
//                           child: Text('Speichern'),
//                           onPressed: () => Navigator.pop(context, _textFieldController.text),
//                         ),
//                       ],
//                     );
//                   },
//                 );
//                 if (result?.isNotEmpty == true && !controller.items.any((element) => element.text == result!)) {
//                   controller.add(
//                     ChipListItem(
//                       text: result!.trim(),
//                       canDelete: true,
//                       icon: Icon(
//                         Icons.style_outlined,
//                         size: 20,
//                       ),
//                     ),
//                   );
//                 }
//               },
//             )
//           ],
//         ),
//       ),
//     );
//   }
// }

// class ChipListItem {
//   String text;
//   Widget? icon;
//   bool? isSelected;
//   bool canDelete;
//   bool removeFlag;
//   ChipListItem({
//     required this.text,
//     this.icon,
//     this.isSelected,
//     required this.canDelete,
//     this.removeFlag = false,
//   });
// }

// class ChipListController extends ChangeNotifier {
//   ChipListController({
//     List<ChipListItem>? items,
//   }) {
//     if (items != null) {
//       _items.addAll(items);
//     }
//   }

//   final List<ChipListItem> _items = [];

//   List<ChipListItem> get items => _items;

//   void add(ChipListItem item) {
//     _clearRemoveFlags();
//     _items.add(item);
//     notifyListeners();
//   }

//   void remove(ChipListItem item) {
//     _items.remove(item);
//     _clearRemoveFlags();
//     notifyListeners();
//   }

//   void clear() {
//     _items.clear();
//     notifyListeners();
//   }

//   void clearRemoveFlags() {
//     _clearRemoveFlags();
//     notifyListeners();
//   }

//   void _clearRemoveFlags() {
//     for (var item in _items) {
//       item.removeFlag = false;
//     }
//   }

//   void shoudRemove(ChipListItem e) {
//     if (e.canDelete && e.removeFlag) {
//       _items.remove(e);
//       notifyListeners();
//     } else if (e.canDelete) {
//       _clearRemoveFlags();
//       e.removeFlag = true;
//       notifyListeners();
//     }
//   }
// }

// class ChipList extends StatelessWidget {
//   ChipList({
//     Key? key,
//     List<ChipListItem>? items,
//     ChipListController? controller,
//     this.onAddPressed,
//   })  : assert(
//           items == null || controller == null,
//           'Use controller constructor to provide intital items.',
//         ),
//         controller = controller ?? ChipListController(items: items),
//         super(key: key);

//   final ChipListController controller;
//   final VoidCallback? onAddPressed;

//   @override
//   Widget build(BuildContext context) {
//     final borderColor = Theme.of(context).colorScheme.secondary;

//     return AnimatedBuilder(
//       animation: controller,
//       builder: (context, _) {
//         return Wrap(
//           runSpacing: 8,
//           spacing: 8,
//           children: [
//             if (onAddPressed != null)
//               ActionChip(
//                 label: Text('Add'),
//                 onPressed: onAddPressed!,
//                 // onPressed: () async {

//                 avatar: Icon(Icons.add),
//               ),
//             ...controller.items.map(
//               (e) {
//                 final leftPadding = e.icon == null ? 16.0 : 4.0;
//                 final rightPadding = e.canDelete == true ? 4.0 : 16.0;

//                 return InputChip(
//                   backgroundColor: Colors.transparent,
//                   shape: StadiumBorder(
//                     side: BorderSide(width: 0.0, color: borderColor),
//                   ),
//                   padding: EdgeInsets.all(0.0),
//                   avatar: e.icon == null
//                       ? null
//                       : CircleAvatar(
//                           child: e.icon,
//                           backgroundColor: Colors.transparent,
//                         ),
//                   label: Text(e.text),
//                   labelPadding: EdgeInsets.only(left: leftPadding, right: rightPadding),
//                   visualDensity: VisualDensity.compact,
//                   deleteIconColor: e.removeFlag == true ? Colors.red.shade400 : null,
//                   selectedColor: Colors.transparent,
//                   onSelected: (_) => controller.clearRemoveFlags(),
//                   onDeleted: e.canDelete == false ? null : () => controller.shoudRemove(e),
//                 );
//               },
//             ).toList()
//           ],
//         );
//       },
//     );
//   }
// }
