import 'package:flutter/material.dart';

import 'color_palette.dart';

const colorsGrey = "GRAU";
const colorsBrown = "BRAUN";
const colorsDeepOrange = "DUNKLES ORANGE";
const colorsOrange = "ORANGE";
const colorsAmber = "BERNSTEINGELB";
const colorsYellow = "GELB";
const colorsLime = "GELBGRÜN";
const colorsLightGreen = "HELLGRÜN";
const colorsGreen = "GRÜN";
const colorsTeal = "BLAUGRÜN";
const colorsBlueGrey = "BLAUGRAU";
const colorsRed = "ROT";
const colorsPink = "PINK";
const colorsPurple = "LILA";
const colorsDeepPurple = "DUNKLES LILA";
const colorsIndigo = "INDIGO";
const colorsBlue = "BLAU";
const colorsLightBlue = "HELLBLAU";
const colorsCyan = "CYAN";
const colorsBlack = "SCHWARZ";
const colorsWhite = "WEIß";

class ColorTable {
  static final variantsWithBaseColor = true;

  List<ColorPalette> get palettes => _palettes;

  static final _palettes = [
    ColorPalette(
      title: colorsRed,
      colorName: 'red',
      primary: Colors.red,
      accent: Colors.redAccent,
      threshold: 300,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsPink,
      colorName: 'pink',
      primary: Colors.pink,
      accent: Colors.pinkAccent,
      threshold: 200,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsPurple,
      colorName: 'purple',
      primary: Colors.purple,
      accent: Colors.purpleAccent,
      threshold: 200,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsDeepPurple,
      colorName: 'deepPurple',
      primary: Colors.deepPurple,
      accent: Colors.deepPurpleAccent,
      threshold: 200,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsIndigo,
      colorName: 'indigo',
      primary: Colors.indigo,
      accent: Colors.indigoAccent,
      threshold: 200,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsBlue,
      colorName: 'blue',
      primary: Colors.blue,
      accent: Colors.blueAccent,
      threshold: 400,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsLightBlue,
      colorName: 'lightBlue',
      primary: Colors.lightBlue,
      accent: Colors.lightBlueAccent,
      threshold: 500,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsCyan,
      colorName: 'cyan',
      primary: Colors.cyan,
      accent: Colors.cyanAccent,
      threshold: 600,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsTeal,
      colorName: 'teal',
      primary: Colors.teal,
      accent: Colors.tealAccent,
      threshold: 400,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsGreen,
      colorName: 'green',
      primary: Colors.green,
      accent: Colors.greenAccent,
      threshold: 500,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsLightGreen,
      colorName: 'lightGreen',
      primary: Colors.lightGreen,
      accent: Colors.lightGreenAccent,
      threshold: 600,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsLime,
      colorName: 'lime',
      primary: Colors.lime,
      accent: Colors.limeAccent,
      threshold: 800,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsYellow,
      colorName: 'yellow',
      primary: Colors.yellow,
      accent: Colors.yellowAccent,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsAmber,
      colorName: 'amber',
      primary: Colors.amber,
      accent: Colors.amberAccent,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsOrange,
      colorName: 'orange',
      primary: Colors.orange,
      accent: Colors.orangeAccent,
      threshold: 700,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsDeepOrange,
      colorName: 'deepOrange',
      primary: Colors.deepOrange,
      accent: Colors.deepOrangeAccent,
      threshold: 400,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsBrown,
      colorName: 'brown',
      primary: Colors.brown,
      threshold: 200,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsGrey,
      colorName: 'grey',
      primary: Colors.grey,
      threshold: 500,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsBlueGrey,
      colorName: 'blueGrey',
      primary: Colors.blueGrey,
      threshold: 500,
      variantsWithBaseColor: variantsWithBaseColor,
    ),
    ColorPalette(
      title: colorsBlack,
      colorName: 'black',
      primary: Colors.black,
      singleColor: true,
    ),
    ColorPalette(
      title: colorsWhite,
      colorName: 'white',
      primary: Colors.white,
      singleColor: true,
    ),
  ];
}
