import 'package:dotup_flutter_widgets/dotup_flutter_widgets.dart';
import 'package:flutter/material.dart';

class BrightnessColor {
  final Color? dark;
  final Color? light;
  static bool isDark = false;

  const BrightnessColor({this.dark, this.light}) : assert(dark != null || light != null);

  Color get color => isDark ? dark ?? light! : light ?? dark!;
}

class DotupLogo extends StatelessWidget {
  DotupLogo({
    Key? key,
    this.size = 60,
    this.borderColor = Colors.white38,
    this.textColor = Colors.white70,
    this.colorRight = Colors.black26,
    Color? colorLeft,
    this.text = 'UP',
  })  : this.colorLeft = colorLeft ?? Colors.grey.shade700,
        super(key: key);

  final double size;
  final Color borderColor;
  final Color textColor;
  final Color colorLeft;
  final Color colorRight;
  final String text;
  final BrightnessColor borderColors = BrightnessColor(dark: Colors.white38);

  @override
  Widget build(BuildContext context) {
    return FittedBox(
      fit: BoxFit.contain,
      child: Container(
        width: size,
        height: size,
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(size / 2),
          border: Border.fromBorderSide(
            BorderSide(width: 1.5, color: borderColors.color),
          ),
          gradient: LinearGradient(
            colors: [
              colorRight,
              colorLeft,
            ],
            begin: Alignment.bottomRight,
            end: Alignment.topLeft,
          ),
        ),
        child: Center(
          child: FittedBox(
            child: Text(
              text,
              style: TextStyle(
                fontSize: size /
                    ResponsiveValue.upto(
                      // small: 4,
                      medium: 3,
                      xlarge: 2,
                    ).value(context),
                color: textColor,
              ),
            ),
          ),
        ),
      ),
    );
  }
}
