import 'package:flutter/material.dart';

import 'dotup_logo.dart';

class DotupSplashScreen extends StatelessWidget {
  const DotupSplashScreen({
    Key? key,
    required this.onTap,
    this.content,
    required this.color,
  }) : super(key: key);

  final VoidCallback onTap;
  final Widget? content;
  final Color color;

  @override
  Widget build(BuildContext context) {
    return Material(
      child: InkWell(
        onTap: onTap,
        child: Container(
          color: color,
          child: Column(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: [
              Expanded(
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.stretch,
                  mainAxisAlignment: MainAxisAlignment.start,
                  children: [
                    const SizedBox(height: 60),
                    const Center(child: Text('dotup IT solutions')),
                    const SizedBox(height: 30),
                    SizedBox(height: 60, width: 60, child: DotupLogo(size: 60)),
                    const SizedBox(height: 30),
                    if (content != null) content!,
                  ],
                ),
              ),
              Padding(
                padding: EdgeInsets.all(16),
                child: TextButton(
                  onPressed: onTap,
                  child: const Padding(
                    padding: EdgeInsets.all(16.0),
                    child: Text('weiter'),
                  ),
                ),
              )
            ],
          ),
        ),
      ),
    );
  }
}
  
  //   return FutureBuilder(
  //     future: Future.delayed(const Duration(seconds: 3)),
  //     builder: (context, snapshot) {
  //       if (snapshot.connectionState == ConnectionState.done) {
  //         Navigator.of(context).restorablePushReplacementNamed(OperationListView.routeName);
  //         return SizedBox.shrink();
  //       } else {
  //         return Material(
  //           child: Container(
  //             color: const Color.fromARGB(255, 0x26, 0x27, 0x4f),
  //             child: Center(
  //               child: Text('tobaccoland'),
  //             ),
  //           ),
  //         );
  //       }
  //     },
  //   );
  // }
// }
