import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

class CirclePainter extends CustomPainter {
  CirclePainter({required this.offset, required this.color});

  final List<Offset> offset;
  final Color color;
  final Paint lightBluePaint = Paint()..color = Color(0xFFbde5fa);
  final Paint bluePaint = Paint()..color = Color(0xFF5abef2);
  final TextPainter textPainter = TextPainter(
    textDirection: TextDirection.ltr,
    textAlign: TextAlign.start,
  );

  final TextStyle textStyle = TextStyle(
    color: Colors.white.withAlpha(240),
    fontSize: 22,
    letterSpacing: 1,
    fontWeight: FontWeight.w900,
  );

  @override
  void paint(Canvas canvas, Size size) {
    if (offset.isEmpty) {
      return;
    }

    final paint = Paint();
    paint.color = color;
    var index = 0;
    offset.forEach((element) {
      Offset center = Offset(20 / 2, 20 / 2);
      final pos = Offset(element.dx + center.dx, element.dy + center.dy);
      // Rect rect = Rect.fromCircle(center: center, radius: 360);
      canvas.drawCircle(element, 20.0, paint);
      // TextSpan span = TextSpan(style: new TextStyle(color: Colors.grey[600]), text: '1');
      // TextPainter tp = TextPainter(text: span, textAlign: TextAlign.center);
      // tp.layout();
      // tp.paint(canvas, element);
      //      var rect = Rect.fromLTRB(
      //     -100, size.height - 120, size.width * 0.7, size.height + 250);

      // final Path circle = Path()..addOval(rect);
      // final Path smallCircle = Path()..addOval(rect.inflate(50));

      // canvas.drawPath(smallCircle, lightBluePaint);
      // canvas.drawPath(circle, bluePaint);

//      drawText(canvas, size, (++index).toString(), Offset(element.dx - center.dx, element.dy - center.dy));
      drawText(canvas, size, (++index).toString(), element);
    });
  }

  void drawText(Canvas canvas, Size size, String text, Offset offset) {
    textPainter.text = TextSpan(style: textStyle, text: text);
    textPainter.layout();
    textPainter.paint(canvas, Offset((offset.dx - (textPainter.width * 0.5)), offset.dy - (textPainter.height) * 0.5));
  }

  @override
  bool shouldRepaint(covariant CustomPainter oldDelegate) {
    return (oldDelegate as CirclePainter).offset.length != offset.length;
  }
}
