import 'package:flutter/widgets.dart';

class LayerDescriptor<T extends Enum> {
  final T key;
  final WidgetBuilder builder;
  bool visible;

  LayerDescriptor({
    required this.key,
    required this.builder,
    this.visible = true,
  });

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is LayerDescriptor<T> && other.key == key && other.builder == builder;
  }

  @override
  int get hashCode => key.hashCode ^ builder.hashCode;

  @override
  String toString() => 'LayerBuilder(key: $key, builder: $builder, visible: $visible)';
}
