import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

import 'layer.dart';
import 'layer_controller.dart';

// class LayerContent {
//   LayerContent({required this.child, this.container});
//   Widget Function(List<Widget> children)? container;
//   Widget child;
// }

class LayerContainer extends StatelessWidget {
  const LayerContainer({
    Key? key,
    required this.builder,
    required this.visible,
  }) : super(key: key);

  final WidgetBuilder builder;
  final bool visible;

  @override
  Widget build(BuildContext context) {
    return Visibility(visible: visible, child: builder(context));
  }
}

class LayerStack extends StatelessWidget {
  const LayerStack({
    Key? key,
    // required this.device,
    // required this.builder,
    required this.layers,
    required this.onBuild,
  }) : super(key: key);

  // final DeviceDescriptor device;
  // final WidgetBuilder builder;
  final ValueSetter<MediaQueryData> onBuild;
  final List<Layer> layers;

  @override
  Widget build(BuildContext context) {
    // TODO: consumer not required?

    onBuild(MediaQuery.of(context));

    final List<Widget> stackContent = [];
    for (var layer in layers) {
      final List<Widget> layerContent = layer.layers
          //     .where(
          //   (element) => element.visible,
          // )
          .map(
        (e) {
          return Selector<LayerController, bool>(
            builder: (context, value, child) {
              return LayerContainer(builder: e.builder, visible: value);
            },
            selector: (context, controller) {
              final builder = controller.getBuilder(e.key);
              return builder?.visible ?? false;
            },
          );
        },
      ).toList();

      stackContent.addAll(layerContent);

      // if (layer.wrapper == null) {
      //   stackContent.addAll(layerContent);
      // } else {
      //   stackContent.add(
      //     layer.wrapper!(
      //       Stack(
      //         overflow: Overflow.visible,
      //         // fit: StackFit.expand,
      //         children: layerContent,
      //       ),
      //     )(context),
      //   );
      // }
    }

    return Stack(
      clipBehavior: Clip.none,
      children: stackContent,
    );
    // return Stack(
    //   children: [
    //     // ...layers.map((e) {}),
    //     for (var layer in layers)
    //       ...layer.layers
    //           //     .where(
    //           //   (element) => element.visible,
    //           // )
    //           .map(
    //         (e) {
    //           var visible = false;
    //           return Selector<LayerController, bool>(
    //             builder: (context, value, child) {
    //               visible = true;
    //               return layer.wrapper == null ? e.builder(context) : layer.wrapper!(e.builder(context))(context);
    //               // return e.builder(context);
    //             },
    //             selector: (context, controller) {
    //               return controller.getBuilder(e.key)?.visible != visible;
    //             },
    //           );
    //         },
    //       ).toList(),
    //   ],
    // );
  }
}
