import 'package:flutter/material.dart';

class HeaderFooter extends StatelessWidget {
  const HeaderFooter._(
      {Key? key,
      // this.header,
      // required this.body,
      // this.footer,
      // this.elevation = 20,
      // this.clipBehavior = Clip.antiAliasWithSaveLayer,
      // ShapeBorder? shape,
      // this.crossAxisAlignment = CrossAxisAlignment.stretch,
      // this.expandBody = true,
      required this.builder})
      : super(key: key);

  // HeaderFooter _({required WidgetBuilder builder}) {
  //   _builder = builder;
  //   return HeaderFooter(body: body);
  // }

  factory HeaderFooter.container({
    Widget? header,
    required Widget body,
    Widget? footer,
    Clip clipBehavior = Clip.none,
    Decoration? decoration,
    CrossAxisAlignment crossAxisAlignment = CrossAxisAlignment.stretch,
    MainAxisAlignment mainAxisAlignment = MainAxisAlignment.end,
    MainAxisSize mainAxisSize = MainAxisSize.min,
    bool expandBody = true,
  }) {
    return HeaderFooter._(
      builder: (_) => Container(
        // key: GlobalKey(),
        clipBehavior: clipBehavior,
        decoration: decoration,
        child: Column(
          crossAxisAlignment: crossAxisAlignment,
          mainAxisAlignment: mainAxisAlignment,
          mainAxisSize: mainAxisSize,
          children: [
            if (header != null) header,
            expandBody ? Expanded(child: body) : body,
            if (footer != null) footer,
          ],
        ),
      ),
    );
  }

  factory HeaderFooter.column({
    Widget? header,
    required Widget body,
    Widget? footer,
    CrossAxisAlignment crossAxisAlignment = CrossAxisAlignment.stretch,
    MainAxisAlignment mainAxisAlignment = MainAxisAlignment.end,
    MainAxisSize mainAxisSize = MainAxisSize.min,
    bool expandBody = true,
  }) {
    return HeaderFooter._(
      builder: (_) => Column(
        crossAxisAlignment: crossAxisAlignment,
        mainAxisAlignment: mainAxisAlignment,
        mainAxisSize: mainAxisSize,
        children: [
          if (header != null) header,
          expandBody ? Expanded(child: body) : body,
          if (footer != null) footer,
        ],
      ),
    );
  }

  factory HeaderFooter.card({
    Widget? header,
    required Widget body,
    Widget? footer,
    double elevation = 20,
    Clip clipBehavior = Clip.antiAliasWithSaveLayer,
    ShapeBorder? shape,
    CrossAxisAlignment crossAxisAlignment = CrossAxisAlignment.stretch,
    MainAxisAlignment mainAxisAlignment = MainAxisAlignment.end,
    MainAxisSize mainAxisSize = MainAxisSize.min,
    bool expandBody = true,
  }) {
    return HeaderFooter._(
      builder: (_) => Card(
        // key: GlobalKey(),
        elevation: elevation,
        clipBehavior: clipBehavior,
        shape: shape,
        child: Column(
          crossAxisAlignment: crossAxisAlignment,
          mainAxisAlignment: mainAxisAlignment,
          mainAxisSize: mainAxisSize,
          children: [
            if (header != null) header,
            expandBody ? Expanded(child: body) : body,
            if (footer != null) footer,
          ],
        ),
      ),
    );
    // return HeaderFooter._(
    //   builder:(_)=> Card(
    //   // key: GlobalKey(),
    //   elevation: elevation,
    //   clipBehavior: clipBehavior,
    //   shape: shape,
    //   child: Column(
    //     crossAxisAlignment: crossAxisAlignment,
    //     mainAxisAlignment: MainAxisAlignment.end,
    //     mainAxisSize: MainAxisSize.min,
    //     children: [
    //       if (header != null) header!,
    //       expandBody ? Expanded(child: body) : body,
    //       if (footer != null) footer!,
    //     ],
    //   ),
    // );
    // );
  }
  // final Widget? header;
  // final Widget body;
  // final Widget? footer;
  // final double elevation;
  // final Clip clipBehavior;
  // late final ShapeBorder shape;
  // final CrossAxisAlignment crossAxisAlignment;
  // final bool expandBody;
  final WidgetBuilder builder;

  @override
  Widget build(BuildContext context) {
    return builder(context);
    // return Card(
    //   // key: GlobalKey(),
    //   elevation: elevation,
    //   clipBehavior: clipBehavior,
    //   shape: shape,
    //   child: Column(
    //     crossAxisAlignment: crossAxisAlignment,
    //     mainAxisAlignment: MainAxisAlignment.end,
    //     mainAxisSize: MainAxisSize.min,
    //     children: [
    //       if (header != null) header!,
    //       expandBody ? Expanded(child: body) : body,
    //       if (footer != null) footer!,
    //     ],
    //   ),
    // );
  }
}
