import 'package:flutter/material.dart';

class HeaderFooterCard extends StatelessWidget {
  HeaderFooterCard({
    Key? key,
    this.header,
    required this.body,
    this.footer,
    this.elevation = 20,
    this.clipBehavior = Clip.antiAliasWithSaveLayer,
    ShapeBorder? shape,
    this.crossAxisAlignment = CrossAxisAlignment.stretch,
    this.expandBody = true,
  }) : super(key: key) {
    this.shape = shape ??
        RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(50),
        );
  }

  final Widget? header;
  final Widget body;
  final Widget? footer;
  final double elevation;
  final Clip clipBehavior;
  late final ShapeBorder shape;
  final CrossAxisAlignment crossAxisAlignment;
  final bool expandBody;

  @override
  Widget build(BuildContext context) {
    return Card(
      // key: GlobalKey(),
      elevation: elevation,
      clipBehavior: clipBehavior,
      shape: shape,
      child: Column(
        crossAxisAlignment: crossAxisAlignment,
        mainAxisAlignment: MainAxisAlignment.end,
        mainAxisSize: MainAxisSize.min,
        children: [
          if (header != null) header!,
          expandBody ? Expanded(child: body) : body,
          if (footer != null) footer!,
        ],
      ),
    );
  }
}
