import 'package:flutter/material.dart';

import 'Section.dart';

class SectionFooter extends StatelessWidget {
  final String? text;
  final Widget? child;
  late final EdgeInsetsGeometry padding;
  final Color? color;
  final TextStyle? textStyle;

  SectionFooter({
    Key? key,
    this.text,
    this.child,
    EdgeInsets? padding,
    this.color,
    this.textStyle,
  })  : assert(
          text != null || child != null,
        ),
        super(key: key) {
    this.padding = padding ??
        EdgeInsets.fromLTRB(
            Section.DEFAULT_CONTENT_PADDING, Section.DEFAULT_CONTENT_PADDING / 2, Section.DEFAULT_CONTENT_PADDING, 0);
  }

  @override
  Widget build(BuildContext context) {
    Widget content;

    if (child == null) {
      // final currentColor = color ?? Theme.of(context).accentColor; // Colors.white70;
      final style = textStyle ?? Theme.of(context).textTheme.caption!.copyWith(color: color, fontSize: 12);
      content = Text(
        text!,
        style: style,
      );
    } else {
      content = child!;
    }

    return Padding(
      padding: padding,
      child: content,
    );
  }
}
