import 'package:flutter/material.dart';

import 'Section.dart';

class SectionHeader extends StatelessWidget {
  final String? text;
  final Widget? child;
  late final EdgeInsetsGeometry padding;
  final Color? color;
  final Color? backgroundColor;
  final TextStyle? textStyle;

  SectionHeader({
    Key? key,
    this.text,
    this.child,
    EdgeInsets? padding,
    this.color,
    this.backgroundColor,
    this.textStyle,
  })  : assert(
          text != null || child != null,
        ),
        super(key: key) {
    this.padding = padding ??
        EdgeInsets.fromLTRB(
          Section.DEFAULT_CONTENT_PADDING,
          Section.DEFAULT_CONTENT_PADDING,
          Section.DEFAULT_CONTENT_PADDING,
          Section.DEFAULT_CONTENT_PADDING/2,
        );
  }

  @override
  Widget build(BuildContext context) {
    // Widget content;
    final style = textStyle ?? Theme.of(context).textTheme.caption!.copyWith(color: color, fontSize: 14);

    // if (child == null) {
    //   // final currentColor = color ?? Theme.of(context).accentColor; // Colors.white70;

    //   content = Text(
    //     text!,
    //     style: style,
    //   );
    // } else {
    //   content = child!;
    // }
    return DefaultTextStyle(
      style: style,
      child: Container(
        color: backgroundColor,
        child: Padding(
          padding: padding,
          child: child == null ? Text(text!) : child,
        ),
      ),
    );
  }
}
