import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

class SectionView extends StatelessWidget {
  late final EdgeInsetsGeometry padding;
  final List<Widget> children;
  final CrossAxisAlignment crossAxisAlignment;

  SectionView({
    Key? key,
    EdgeInsets? padding,
    required this.children,
    this.crossAxisAlignment = CrossAxisAlignment.start,
    ScrollController? scrollController,
  })  : controller = scrollController ?? ScrollController(),
        super(key: key) {
    this.padding = padding ?? EdgeInsets.zero;
  }

  final ScrollController controller;

  @override
  build(BuildContext context) {
    return SingleChildScrollView(
      controller: controller,
      padding: padding,
      child: Column(
        mainAxisSize: MainAxisSize.min,
        crossAxisAlignment: crossAxisAlignment,
        children: children,
      ),
    );
  }
}
