import 'package:flutter/widgets.dart';

class HexColor extends Color {
  HexColor(final int colorValue) : super(colorValue);

  factory HexColor.fromString(String hexColor) {
    return HexColor(_getColorFromHex(hexColor));
  }

  static int _getColorFromHex(String hexColor) {
    hexColor = hexColor.replaceAll('#', '');
    hexColor = hexColor.replaceAll('0x', '');

    if (hexColor.length == 6) {
      hexColor = 'FF' + hexColor;
    }
    return int.parse(hexColor, radix: 16);
  }

  Color asColor() {
    return this;
  }

  @override
  String toString() {
    var temp = super.toString();
    temp = temp.substring(6, temp.indexOf(')'));
    return temp;
  }

  static HexColor? fromValue(int? value) {
    return value == null ? null : HexColor(value);
  }

  static HexColor? fromColor(Color? color) {
    return color == null ? null : HexColor(color.value);
  }
}
