import 'package:dotup_dart_utils/dotup_dart_utils.dart';
import 'package:flutter/widgets.dart';

typedef Widget WidgetFactory();
typedef WidgetSelectorFactory = KeyValueOf<Type, WidgetFactory>;

class WidgetSelector extends StatelessWidget {
  final Object value;
  final List<WidgetSelectorFactory> widgetFactories;

  const WidgetSelector({
    required this.value,
    required this.widgetFactories,
    Key? key,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    final xx = value.runtimeType;
    var builder = widgetFactories.firstWhereOrNull((item) => item.key == xx);
    return builder!.value();
  }
}

Widget widgetSelector(Object value, List<WidgetSelectorFactory> selector) {
  final xx = value.runtimeType;
  var builder = selector.firstWhereOrNull((item) => item.key == xx);
  return builder!.value();
}


// void widgetSelectorTest() {
//   var x = "WidgetSelector()";
//   // organisation: 'dotup',

//   var result = widgetSelector(x, [
//     KeyValueOf(String, () => Text("data")),
//     KeyValueOf(WidgetSelectorFactory, () => Text("WidgetSelector")),
//   ]);
// }
